=== automation/requirements.txt ===
jira
python-gitlab
slack_sdk
github3.py
atlassian-python-api
